//
//	File:			Memory.java
//	Author:		Krzysztof Langner
//	Date:			1997/04/28
//

import java.util.*;

class Memory
{

   Pos LandMarkPos[] =
   {
      new Pos(  0.0,  0.0),
      new Pos( 52.5,  0.0), new Pos(-52.5,  0.0),   //goal r l
      new Pos( 52.5, -34.0), new Pos( 52.5, 34.0),   //flag r t, r b
      new Pos(  0.0, -34.0), new Pos(  0.0, 34.0),   //flag c t, c b
      new Pos(-52.5, -34.0), new Pos(-52.5, 34.0),   //flag l t, l b
      new Pos( 36.0, -20.16), new Pos( 36.0,  0.0), new Pos( 36.0, 20.16),  //flag prt, prc, prb
      new Pos(-36.0, -20.16), new Pos(-36.0,  0.0), new Pos(-36.0, 20.16),  //flag plt, plc, plb
      new Pos(-52.5, -6.0), new Pos(-52.5,  6.0),   //flag glt glb
      new Pos(52.5, -6.0), new Pos(52.5,  6.0), //flag grt grb
      new Pos(  0.0,  0.0)
   };

   String LandMarkStr[] =
   {
      "ball",
      "goal r",
      "goal l",
      "flag r t",
      "flag r b",
      "flag c t",
      "flag c b",
      "flag l t",
      "flag l b",
      "flag p r t",
      "flag p r c",
      "flag p r b",
      "flag p l t",
      "flag p l c",
      "flag p l b",
      "flag g l t",
      "flag g l b",
      "flag g r t",
      "flag g r b"
   };

   int LM_ball=0;
   int LM_goal=1;
   int LM_owngoal=2;
   int LM_flag_fl=3;
   int LM_flag_fr=4;
   int LM_flag_cl=5;
   int LM_flag_cr=6;
   int LM_flag_bl=7;
   int LM_flag_br=8;
   int LM_flag_pfl=9;
   int LM_flag_pfc=10;
   int LM_flag_pfr=11;
   int LM_flag_pbl=12;
   int LM_flag_pbc=13;
   int LM_flag_pbr=14;
   int LM_max=15;


   private final double DEG2RAD =  (Math.PI / (double)180.0);
   private final double RAD2DEG = (double)((double)180.0 / Math.PI);

   private boolean positionEstimated = false;

   static Hashtable flagPos=new Hashtable(60);

	//---------------------------------------------------------------------------
	// This constructor:
	// - initializes all variables
	public Memory(char side)
   {
      m_side=side;
      setFlagPos(flagPos);
      debug("Memory.memory: m_side="+m_side+" hashTable.size="+flagPos.size());
	}

   private void setFlagPos(Hashtable flagPos)
   {
      //flags on lines around playing field
      flagPos.put("l t", new Pos(-52.5, -34));
      flagPos.put("c t", new Pos(0, -34));
      flagPos.put("r t", new Pos(52.5, -34));
      flagPos.put("g r t", new Pos(52.5, -8));
      flagPos.put("g r b", new Pos(52.5, 8));
      flagPos.put("r b", new Pos(52.5, 34));
      flagPos.put("c b", new Pos(0, 34));
      flagPos.put("l b", new Pos(-52.5, 34));
      flagPos.put("g l b", new Pos(-52.5, 8));
      flagPos.put("g l t", new Pos(-52.5, -8));

      //----flags outside lines----------------
      //outside top line
      flagPos.put("t l 50", new Pos(-50, -39));
      flagPos.put("t l 40", new Pos(-40, -39));
      flagPos.put("t l 30", new Pos(-30, -39));
      flagPos.put("t l 20", new Pos(-20, -39));
      flagPos.put("t l 10", new Pos(-10, -39));
      flagPos.put("t 0", new Pos(0, -39));
      flagPos.put("t r 10", new Pos(10, -39));
      flagPos.put("t r 20", new Pos(20, -39));
      flagPos.put("t r 30", new Pos(30, -39));
      flagPos.put("t r 40", new Pos(40, -39));
      flagPos.put("t r 50", new Pos(50, -39));
      //outside right line
      flagPos.put("r t 30", new Pos(57.5, -30));
      flagPos.put("r t 20", new Pos(57.5, -20));
      flagPos.put("r t 10", new Pos(57.5, -10));
      flagPos.put("r 0", new Pos(57.5, 0));
      flagPos.put("r b 10", new Pos(57.5, 10));
      flagPos.put("r b 20", new Pos(57.5, 20));
      flagPos.put("r b 30", new Pos(57.5, 30));
      //outside bottom line
      flagPos.put("b r 50", new Pos(50, 39));
      flagPos.put("b r 40", new Pos(40, 39));
      flagPos.put("b r 30", new Pos(30, 39));
      flagPos.put("b r 20", new Pos(20, 39));
      flagPos.put("b r 10", new Pos(10, 39));
      flagPos.put("b 0", new Pos(0, 39));
      flagPos.put("b l 10", new Pos(-10, 39));
      flagPos.put("b l 20", new Pos(-20, 39));
      flagPos.put("b l 30", new Pos(-30, 39));
      flagPos.put("b l 40", new Pos(-40, 39));
      flagPos.put("b l 50", new Pos(-50, 39));
      //outside left line
      flagPos.put("l b 30", new Pos(-57.5, 30));
      flagPos.put("l b 20", new Pos(-57.5, 20));
      flagPos.put("l b 10", new Pos(-57.5, 10));
      flagPos.put("l 0", new Pos(-57.5, 0));
      flagPos.put("l t 10", new Pos(-57.5, -10));
      flagPos.put("l t 20", new Pos(-57.5, -20));
      flagPos.put("l t 30", new Pos(-57.5, -30));

      //flags inside playing field
      flagPos.put("p l t", new Pos(-36, -20.16));
      flagPos.put("p l c", new Pos(-36, 0));
      flagPos.put("p l b", new Pos(-36, 20.16));
      flagPos.put("c", new Pos(0, 0));
      flagPos.put("p r t", new Pos(36, -20.16));
      flagPos.put("p r c", new Pos(36, 0));
      flagPos.put("p r b", new Pos(36, 20.16));
   }

	//---------------------------------------------------------------------------
	// This function puts see information into our memory
	public void store(VisualInfo info)
	{
      debug("Memory.store()");//+info.toString().trim());


      if (info == null)
      {
         debug("Memory is NULL.....");
         positionEstimated = false;
         return;
      }
      else
      {
         m_info = info;
      }

      //estimateCurrentPosition ();

/*      int i;
      for (i=0; i<m_info.m_objects.size());
      {



      }*/

	}

	//---------------------------------------------------------------------------
	// This function looks for specified object
	public ObjectInfo getObject(String name)
	{
      debug("Memory.getObject()");
		if( m_info == null )
			waitForNewInfo();

      int c;
		for(c = 0 ; c < m_info.m_objects.size() ; c ++)
		{
			ObjectInfo object = (ObjectInfo)m_info.m_objects.elementAt(c);
			if(object.m_name.compareTo(name) == 0)
				return object;
		}

		return null;
	}




	//---------------------------------------------------------------------------
	// This function waits for new visual information
	public void waitForNewInfo() 
	{
		// first remove old info

      debug("!!! WAIT FOR NEW INFO !!!");

		m_info = null;
		// now wait until we get new copy
		while(m_info == null)
		{
			// We can get information faster then 75 miliseconds
			try
			{
				Thread.sleep(SIMULATOR_STEP / 10);
			}
			catch(Exception e)
			{
			}
		}

      if (Krislet.server_time == -1)
      {
         debug("Znova ten isty cas, cakam...");
         waitForNewInfo();
      }
	}


/*   private ObjectInfo updatePositionInObject(ObjectInfo info)
   {
      int i;

      //naplnenie tabulky info o znackach...
      for (i=LM_ball; i<LM_max; i++)
      {
         if (info.m_name.equals(LandMarkStr[i]))
         {
            info.pos=LandMarkPos[i];
            i=LM_max+1;
         }
      }
      return(info);
   }*/


   //------ added by jeeff ------------
   // This function try to estimate current position
   public void estimateCurrentPosition()
   {
      Pos pos=new Pos();
      try
      {
      ObjectInfo lm1=null, lm2=null;
      boolean oldp=false;

      decisionInfo=m_info;

      int i,j,k=0;
      ObjectInfo objInfo;
      String name;

      float minDir=999;
      float maxDir=-999;

      for (i=0; i<decisionInfo.m_objects.size(); i++)
      {
         objInfo=(ObjectInfo)decisionInfo.m_objects.elementAt(i);
         name = (String)objInfo.m_name;
         if(name.startsWith("flag "))
         {
            if (objInfo.m_direction < minDir)
            {
               lm1=objInfo;
               minDir = objInfo.m_direction;
            }
            if (objInfo.m_direction > maxDir)
            {
               lm2=objInfo;
               maxDir = objInfo.m_direction;
            }
         }
      }



      //lm1=updatePositionInObject(lm1);
      //lm2=updatePositionInObject(lm2);

      double x1 = lm1.m_pos.x, y1 = lm1.m_pos.y, r1 = lm1.m_distance ;
      double x2 = lm2.m_pos.x, y2 = lm2.m_pos.y, r2 = lm2.m_distance ;
      boolean revp;

      if (y1 == y2) revp=true;
      else revp=false;

      double b ;
      if(revp)
      {
	      b = x1 ; x1 = y1 ; y1 = b ;
	      b = x2 ; x2 = y2 ; y2 = b ;
      }

      double A = (x1 * x1 - x2 * x2) + (y1 * y1 - y2 * y2) - (r1 * r1 - r2 * r2) ;
      double B = -2 * (x1 - x2) ;
      double C = A / (2 * (y1 - y2)) ;
      double D = B / (2 * (y1 - y2)) ;
      double E = 1 + D * D ;
      double F = -x1 + C * D - D * y1 ;
      double G = x1 * x1 + C * C - 2 * C * y1 + y1 * y1 - r1 * r1 ;
      double H0 = F * F - E * G ;
      double H = ((H0 < 0.0)? 0.0 : H0) ;
      double x01 = (- F + Math.sqrt(H)) / E ;
      double x02 = (- F - Math.sqrt(H)) / E ;
      double y01 = C + D * x01 ;
      double y02 = C + D * x02 ;

      if(revp)
      {
	      b = x01; x01=y01; y01=b;
         b = x1; x1=y1; y1=b;
         b = x2; x2=y2; y2=b;
         b = x02; x02=y02; y02=b;
      }

      double theta1 = Atan2((double)(x1-x01),(double)(y1-y01)) - Atan2((double)(x2-x01),(double)(y2-y01));
      theta1 = normalize_angle(theta1) ;
      double theta0 = normalize_angle(-(lm1.m_direction - lm2.m_direction)) ;

      if(theta0*theta1 > 0)
      {
       //  debug("JE > 0 --- THETA1="+theta1+" theta0="+theta0);
	      pos.x = x01 ;
	      pos.y = y01 ;
      } else
      {
         //debug("JE < 0 --- THETA1="+theta1+" theta0="+theta0);
	      pos.x = x02 ;
	      pos.y = y02 ;
      }



      // urcenie uhla pohladu


/*      lm1=(ObjectInfo)decisionInfo.m_objects.elementAt(0);
      for (i=0; i<decisionInfo.m_objects.size(); i++)
      {
         objInfo=(ObjectInfo)decisionInfo.m_objects.elementAt(i);
         name = (String)objInfo.m_name;
         if(name.startsWith("flag ") && (objInfo.m_distance < lm1.m_distance))
         {
            lm1=objInfo;
         }
      }*/

      //lm1 = getObject("flag p l c");

      double bodyDir=0;
      if (lm1!=null) bodyDir = estimateBodyDir(lm1, pos);

      if (m_side=='r')
      {
         pos.x=-pos.x;
         pos.y=-pos.y;
         bodyDir = normalize_angle(180 + bodyDir);
      }

      Krislet.bodyDir = bodyDir;

      this.pos.x = pos.x;
      this.pos.y = pos.y;

      Krislet.pos.x=pos.x;
      Krislet.pos.y=pos.y;

      positionEstimated=true;

      //debug("--Position: x="+(int)pos.x+" y="+(int)pos.y+" m_side="+m_side+" bodyDir="+Krislet.bodyDir);
      }
      catch (Exception ex)
      {
         positionEstimated=false;
         debug("Can't estimate current position: "+ex.getMessage());
         debug("--Position: x="+(int)pos.x+" y="+(int)pos.y+" m_side="+m_side+" bodyDir="+Krislet.bodyDir);
      }
   }

   private double estimateBodyDir(ObjectInfo lm1, Pos pos)
   {

      //debug("lm1.x="+lm1.m_pos.x+" y="+lm1.m_pos.y);
      double x1 = lm1.m_pos.x + 70;
      double y1 = lm1.m_pos.y + 50;
      double m_myDir=0;
      double dx = x1 - pos.x - 70;
		double dy = y1 - pos.y - 50;
      //dx=0;
      //dy=18;
		double dir1 = lm1.m_direction;
      double atan=0;

      if (dx>0)
      {
         atan=Math.atan(dy/dx);
         atan=Math.toDegrees(atan);
         m_myDir = normalize_angle(atan - dir1);
      }
      else if(dx<0)
      {
         atan=Math.atan((-dy)/(-dx));
         atan=Math.toDegrees(atan);
         m_myDir = normalize_angle(180 + atan - dir1);
      }
		else if((dx == 0) && (dy > 0))
      {
			m_myDir = normalize_angle(90 + dir1);
      }
		else if((dx == 0) && (dy < 0))
      {
			m_myDir = normalize_angle(-90 - dir1);
      }


      //debug("dx="+dx+" dy="+dy+" lm1.x="+lm1.m_pos.x+" lm1.y="+lm1.m_pos.y+" name="+lm1.m_name);
      //debug("-->dir="+m_myDir+" dir1="+dir1+" atan="+atan);

      return (m_myDir);

   }

   public boolean isPositionEstimated()
   {
      return (positionEstimated);
   }

   public Pos estimateObjectPosition(ObjectInfo obj)
   {
      double angle = Math.toRadians(obj.m_direction + Krislet.bodyDir);                                                         
	   obj.m_pos.x = pos.x +
	      (int)((double)obj.m_distance * Math.cos(angle)) ;
	   obj.m_pos.y = pos.y +
         (int)((double)obj.m_distance * Math.sin(angle)) ;
	   return (obj.m_pos);
   }

   public double normalize_angle(double ang)
   {
      while(ang >  180.0) ang -= 360.0 ;
      while(ang < -180.0) ang += 360.0 ;
      return ang ;
   }

   public double findClearAngle()
   {
      return(findClearAngle(0.0));
   }

   public double findClearAngle(double angle)
   {
      int i;
      int size = m_info.m_objects.size();
      boolean isPlayer;
      ObjectInfo oInfo;
      try
      {
         for (i=0; i<size; i++)
         {
            oInfo = (ObjectInfo)m_info.m_objects.elementAt(i);
            isPlayer = oInfo.m_type.equals("player");

            //ak sa meni rychlost tak sa na to vypaz...
            if (isPlayer)
            {
               if (Math.abs(oInfo.m_distChange) > 2.0) isPlayer = false;
            }

            //ked je prilis blizko som zaseknuty
            if (oInfo.m_distance < 0.8 && oInfo.m_distance > 0 && isPlayer)
            {
               angle = angle + 20;
               break;
            }
            else if (oInfo.m_distance < 1.5 && oInfo.m_distance > 0 && isPlayer)
            {
               if ( oInfo.m_direction>angle-20 && oInfo.m_direction<angle+20)
               {
                  if (oInfo.m_direction < 0) angle = angle + 20;
                  else angle = angle - 20;
                  break;
               }
            }
            else if (oInfo.m_distance < 3 && oInfo.m_distance > 0 && isPlayer)
            {
               if ( oInfo.m_direction>angle-10 && oInfo.m_direction<angle+10)
               {
                  //if (Math.abs(oInfo.m_direction) < 10)
                  //{
                     if (oInfo.m_direction < 0) angle = angle + 10;
                     else angle = angle - 10;
                  //}
                  //else angle = angle - oInfo.m_direction;
                  break;
               }
            }
            /*else if (oInfo.m_distance < 5 && isPlayer)
            {
               if ( oInfo.m_direction>angle-10 && oInfo.m_direction<angle+10)
               {
                  angle = - oInfo.m_direction;
                  break;
               }
            } */
         }

      }
      catch (Exception ex)
      {

      }
      debug("Hladam cistu cestu!!! uhol="+angle);
      return(angle);
   }

   public double findClearAngleForBall(double angle)
   {
      debug("Hladam cistu cestu pre loptu povodny uhol="+angle);
      int i;
      int size = m_info.m_objects.size();
      boolean isPlayer;
      ObjectInfo oInfo;
      PlayerInfo pInfo;
      try
      {
         for (i=0; i<size; i++)
         {
            oInfo = (ObjectInfo)m_info.m_objects.elementAt(i);
            isPlayer = oInfo.m_type.equals("player");

            if (isPlayer)
            {
               pInfo = (PlayerInfo)m_info.m_objects.elementAt(i);
               debug("Hrac :"+pInfo.m_teamName);
               if (pInfo.m_teamName.equals(Krislet.m_team)) isPlayer=false;
               debug("Hrac :"+pInfo.m_teamName+" isPlayer="+isPlayer);
            }

            if (oInfo.m_distance < 3 && oInfo.m_distance > 0 && isPlayer)
            {
               if ( oInfo.m_direction>angle-20 && oInfo.m_direction<angle+20)
               {
                  if (oInfo.m_direction < 0) angle = angle + 15;
                  else angle = angle - 15;
                  break;
               }
            }
            else if (oInfo.m_distance < 15 && oInfo.m_distance > 0 && isPlayer)
            {
               if ( oInfo.m_direction>angle-10 && oInfo.m_direction<angle+10)
               {
                  //if (Math.abs(oInfo.m_direction) < 10)
                  //{
                     if (oInfo.m_direction < 0) angle = angle + 10;
                     else angle = angle - 10;
                  //}
                  //else angle = angle - oInfo.m_direction;
                  break;
               }
            }
         }

      }
      catch (Exception ex)
      {

      }
      debug("Hladam cistu cestu pre loptu!!! uhol="+angle);
      return(angle);
   }

   public int isNearAgainstPlayer(double ball_dir)
   {
      int i;
      int size = m_info.m_objects.size();
      PlayerInfo pInfo;
      try
      {
         for (i=0; i<size; i++)
         {
            if (m_info.m_objects.elementAt(i) instanceof PlayerInfo)
            {
               pInfo = (PlayerInfo)m_info.m_objects.elementAt(i);
               if (pInfo.m_teamName!=null && !pInfo.m_teamName.equals(Krislet.m_team))
               {
                  if (pInfo.m_distance < 3 &&  Math.abs(pInfo.m_direction - ball_dir) < 10)
                  {
                     debug("!!!Against player is near!!!");
                     if (pInfo.m_direction > 0) return (1);
                     else return(-1);
                  }

               }
            }
         }
      }
      catch (Exception ex)
      {

      }
      return(0);
   }


   //najde najblizsieho utocnika
   public PlayerInfo findNearestForward()
   {
      try
      {
         Pos myPos = new Pos(Krislet.pos.x, Krislet.pos.y);
         debug("Memory.findNearestForward()");
         if( m_info == null )
			   waitForNewInfo();

         int c;
         int nearestIndex=-1;
         double nearestDist=99999;
		   for(c = 0 ; c < m_info.m_objects.size() ; c ++)
		   {
            if (m_info.m_objects.elementAt(c) instanceof PlayerInfo)
            {
			      PlayerInfo object = (PlayerInfo)m_info.m_objects.elementAt(c);
               debug("object: c="+c+" team="+object.m_teamName+" uniform="+object.m_uniformName);
			      if (object.m_teamName!=null && object.m_teamName.equals(Krislet.m_team))
               {
                  Pos objPos = estimateObjectPosition(object);
                  if (objPos.x > Krislet.pos.x)
                  {
                     if (object.m_distance < nearestDist)
                     {
                        nearestDist = object.m_distance;
                        nearestIndex=c;
                     }
                  }
               }
            }
         }

		   if (nearestIndex==-1) return null;
         return ((PlayerInfo)m_info.m_objects.elementAt(nearestIndex));
      }
      catch (Exception ex)
      {
         debug("Nastala vynimka pri hladani utocnika!!!");
         return(null);
      }
   }

   //najde najblizsieho utocnika
   public boolean isSomeoneNear(ObjectInfo ball)
   {
      debug("memory.isSomeoneNear()");
      try
      {
         Pos myPos = new Pos(Krislet.pos.x, Krislet.pos.y);
         if( m_info == null )
			   waitForNewInfo();

         int c;
         boolean isNear=false;
         double nearestDist=ball.m_pos.distance(myPos);
         double tmpDist=0;

		   for(c = 0 ; c < m_info.m_objects.size() ; c ++)
		   {
            if (m_info.m_objects.elementAt(c) instanceof PlayerInfo)
            {
			      PlayerInfo object = (PlayerInfo)m_info.m_objects.elementAt(c);
               //debug("object: c="+c+" team="+object.m_teamName+" uniform="+object.m_uniformName);
			      if (object.m_teamName!=null && object.m_teamName.equals(Krislet.m_team))
               {
                  Pos objPos = estimateObjectPosition(object);
                  tmpDist = objPos.distance(ball.m_pos);
                  if (tmpDist < nearestDist)
                  {
                     isNear = true;
                     break;
                  }
               }
            }
         }

		   return(isNear);
      }
      catch (Exception ex)
      {
         debug("Nastala vynimka pri hladani najblizsieho hraca k lopte!!!");
         return(false);
      }
   }

   //-------added by jeeff ---------
   public double Sin(double x) { return Math.sin(DEG2RAD * x) ; }
   public double Cos(double x) { return Math.cos(DEG2RAD * x) ; }

   public double Atan2(double y, double x)
   {

      double vysledok=RAD2DEG * Math.atan2(y,x);
      //debug("---Atan2() vysledok="+vysledok);
      return(vysledok);

      //double a=y/x;

      //return(RAD2DEG * Math.atan(a));

   }

   public Pos getCurrentPos()
   {
      return(pos);
   }

   public void setCurrentPos(Pos pos)
   {
      this.pos = pos;
   }

   private void debug(String text)
   {
      if (Krislet.DEBUG) System.out.println(text);
   }

//===========================================================================
// Private members
	private VisualInfo	m_info;	// place where all information is stored
	final static int SIMULATOR_STEP = 100;

   private char m_side;
   private VisualInfo            decisionInfo;

   private Pos ball_pos;
   private Vector players = new Vector(22,5);

   int cdir=0;

   private Pos pos=new Pos();

}

